package com.jiuqi.mde;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/* loaded from: com_jiuqi_mde.jar:com/jiuqi/mde/MDEDataInfoSet.class */
public final class MDEDataInfoSet {
    private ArrayList datasets = new ArrayList(128);
    private Map nameSearch = new HashMap(127);

    public int size() {
        return this.datasets.size();
    }

    public void clear() {
        this.datasets.clear();
        this.nameSearch.clear();
    }

    public MDEDataInfo get(int index) {
        return (MDEDataInfo) this.datasets.get(index);
    }

    public MDEDataInfo find(String name) {
        return (MDEDataInfo) this.nameSearch.get(name);
    }

    public void add(MDEDataInfo dataset) {
        if (!this.nameSearch.containsKey(dataset.getName())) {
            this.datasets.add(dataset);
            this.nameSearch.put(dataset.getName(), dataset);
        }
    }

    public void add(int index, MDEDataInfo dataset) {
        if (!this.nameSearch.containsKey(dataset.getName())) {
            this.datasets.add(index, dataset);
            this.nameSearch.put(dataset.getName(), dataset);
        }
    }

    public void add(MDEDataInfoSet datasets) {
        for (int i = 0; i < datasets.size(); i++) {
            add(datasets.get(i));
        }
    }

    public void remove(int index) {
        MDEDataInfo dataset = (MDEDataInfo) this.datasets.get(index);
        this.nameSearch.remove(dataset.getName());
        this.datasets.remove(index);
    }

    public void remove(MDEDataInfo dataset) {
        this.datasets.remove(dataset);
        this.nameSearch.remove(dataset.getName());
    }

    public int indexOf(MDEDataInfo dataset) {
        for (int i = 0; i < this.datasets.size(); i++) {
            MDEDataInfo dim = (MDEDataInfo) this.datasets.get(i);
            if (dim == dataset || dim.getName().equals(dataset.getName())) {
                return i;
            }
        }
        return -1;
    }

    public Object clone() {
        MDEDataInfoSet result = new MDEDataInfoSet();
        result.add(this);
        return result;
    }

    public void sortByName() {
        for (int i = 1; i < this.datasets.size(); i++) {
            MDEDataInfo dataset = (MDEDataInfo) this.datasets.get(i);
            int start = 0;
            int stop = i - 1;
            while (true) {
                if (start > stop) {
                    break;
                }
                int middle = (start + stop) >> 1;
                int flag = dataset.getName().compareTo(((MDEDataInfo) this.datasets.get(middle)).getName());
                if (flag > 0) {
                    start = middle + 1;
                } else if (flag < 0) {
                    stop = middle - 1;
                } else {
                    start = middle;
                    break;
                }
            }
            if (start < i) {
                for (int k = i; k > start; k--) {
                    this.datasets.set(k, this.datasets.get(k - 1));
                }
                this.datasets.set(start, dataset);
            }
        }
    }
}
